-- Volume
function r(y)
  return sqrt(macalc.rcl(1)^2*(1-((macalc.rcl(2)-macalc.rcl(3)+y)^2/macalc.rcl(2)^2)))
end

function rc(r,h)
  return (h^2+r^2) / (2*h)
end

function svol(r,h)
  return h^2*pi/3*(3*rc(r,h)-h)
end

function lua_main()
  h = macalc.rcl(3)
  -- How many times is this sliced?
  slices = 5000
  -- Set iterator
  i = 1
  -- Create delta distance
  d = h/slices
  -- Set initial y-coordinate just below top
  y = h-d
  -- Set total volume to the dome area of top
  t = svol(r(y),d)

  repeat
    -- top y,x and circumference
    ay  = h-d*i
    ax  = r(ay)
    -- bottom y, x and circumference
    by  = h-d*(i+1)
    bx  = r(by)
    -- average difference between radii
    rad = (ax+bx)/2
    
    -- cylinder volume
    vol = pi*rad^2*d

    -- add up area
    t = t + vol
    i = i+1

  until i>=slices

  return t
end
